let langPromise = new Promise(async resolve => {
  const LZString = require("./js/libs/lz-string.js");
  const FORMAT_MAP = {
    "yml":{target:"HERO",delta:false,encrypt:true},
    "ymld":{target:"HERO",delta:true,delta_method:"yaml",encrypt:true},
    "yaml":{target:"HERO",delta:false,encrypt:true},
    "yamld":{target:"HERO",delta:true,delta_method:"yaml",encrypt:true},
    "hero":{target:"HERO",delta:false,encrypt:false}
  };
  let configSaveData = null;
  try {
    let configRpgSave = native_fs.readFileSync(base + "/save/config.rpgsave", {encoding:"utf8"});
    configSaveData = JSON.parse(LZString.decompressFromBase64(configRpgSave));
  } catch (e) {
    alert("failed to load config");
  }
  //console.log(params.mod.basePath);
  //* Load image replacements
  let langOffset = "languages/" + configSaveData.language;
  async function recurseModPath(modPath = "") {
    let readPath = path.join(params.mod.basePath, langOffset, modPath);
    for (modDir of native_fs.readdirSync(readPath)) {
      if (native_fs.statSync(path.join(readPath, modDir)).isDirectory()) {
        recurseModPath(path.join(modPath, modDir));
      } else if (native_fs.statSync(path.join(readPath, modDir)).isFile()) {
        if (path.extname(modDir) === ".olid") {
          let targPath = path.relative("/assets/", modPath).replace(/\\/g, "/") + "/";
          //$modLoader.$log(`${path.join(langOffset, modPath, modDir).replace(/\\/g, "/")}`);
          //$modLoader.$log(`${targPath}${modDir.replace(/\.olid$/, '.png')}`);
          await params.mod.processImageDeltaEntry(
                  `${targPath}${modDir.replace(/\.olid$/, '.png')}`,
                  `${path.join(langOffset, modPath, modDir).replace(/\\/g, "/")}`);
        } else {
          let oogName = path.join(modPath, modDir);
          let extension = "";
          let ogName = modDir;
          try {
              extension = ogName.match(/.([^\.]*$)/)[1].toLowerCase();
          } catch(e) {}
          let injectionPoint = path.join(path.relative("/assets/", modPath), ogName).replace(/\\/g, "/").toLowerCase();
          if (EXTENSION_RULES[extension] && EXTENSION_RULES[extension].target_extension) {
              let target = EXTENSION_RULES[extension].target_extension;
              injectionPoint = injectionPoint.replace(new RegExp(extension + "$"), target);
              ogName = ogName.replace(new RegExp(extension + "$", "i"), target);
          }

          let fileData = {
              injectionPoint,
              ogName,
              mode: (EXTENSION_RULES[extension] && EXTENSION_RULES[extension].encrypt) ? EXTENSION_RULES[extension].encrypt : "pass",
              dataSource: await params.mod.resolveDataSource(path.join(langOffset, oogName)),
              delta: false
          };

          //console.log("A");
          //console.log(fileData);
          params.mod.files.push(fileData);
        }
      }
    }
  }
  recurseModPath("/assets");

  for(let langName of params.mod.json.languages) {
    let langJsonKey = "lang" + langName.toUpperCase();
    let langMountPoint = "languages/" + langName.toLowerCase();
    DATA_RULES.push({jsonKeys: [langJsonKey], formatMap: FORMAT_MAP, mountPoint: langMountPoint});
    params.mod.json.files[langJsonKey] = [langMountPoint + "/text/"];
  }

  resolve();
});

await langPromise;
