{
  LanguageManager = class extends LanguageManager {
	static getTextData(file, name, language) {
	  if (language === undefined) { language = this._language; }
	  if (!this._data[language].text[file][name]) {
		// default to English
		return super.getTextData(file, name, 'en');
	  }

	  return super.getTextData(file, name, language);
	}
    static defaultLanguage() {return 'sc'}
		static loadLanguageFiles(language) {
      //alert("language " + language);
			//if(!!Utils.isOptionValid("test")) {return super.loadLanguageFiles(language);}
      //console.log("AAAAAAAAAAAAAA")
			const path = require('path');
			const fs = require('fs');
			const yaml = require('./js/libs/js-yaml-master')
			var base = path.dirname(process.mainModule.filename);

			let folder = "/Languages/" + language + "/";
      let defaultLangPath = base + "/Languages/en/"
			let filePath = base + folder;
			let dirList = fs.readdirSync(defaultLangPath);
			this._data[language] = {text: {}, meta: {}};
			for(let directory of dirList) {
        let inLanguagePath = path.join(filePath, directory);
        let existsInLanguage = fs.existsSync(inLanguagePath);
        if(!existsInLanguage) {
          inLanguagePath = path.join(defaultLangPath, directory);
        }
				let format = path.extname(directory);
				let filename = path.basename(directory, format);
        //$modLoader.$log(language + ": " + (inLanguagePath == path.join(defaultLangPath, directory)) + " : " + directory);
				if(format === ".HERO") {
					let buff = fs.readFileSync(inLanguagePath);
					buff = Encryption.decrypt(buff);
          if (filename == "language" && existsInLanguage) {
            this._data[language].meta = yaml.safeLoad(buff.toString());
            console.log("Meta found for " + language)
          } else {
					  this._data[language].text[filename] = yaml.safeLoad(buff.toString());
          }
				}
        if(format === ".yaml") {
					let buff = fs.readFileSync(inLanguagePath, 'utf-8');
          if (filename == "language" && existsInLanguage) {
            this._data[language].meta = yaml.safeLoad(buff.toString());
            console.log("Meta found for " + language)
          } else {
					  this._data[language].text[filename] = yaml.safeLoad(buff.toString());
          }
				}
			}
		}
	}

  LanguageManager.initialize();

  LanguageManager = class extends LanguageManager {
    static initialize() {
      return false;
    }
  }

  ConfigManager = class extends ConfigManager {
    static makeData() {
      let config = super.makeData()
      config.language = LanguageManager._language
      return config
    }
    static applyData(config) {
      super.applyData(config)
      LanguageManager._language = config.language || LanguageManager.defaultLanguage()
    }
  }
}
