
    let spainMode = false;

    class MeowSystemLanguage extends Window_Command {
        constructor() { super(...arguments); }
        makeCommandList() {
          let isSceneTitle = SceneManager._scene instanceof Scene_OmoriTitleScreen;
          this.isUsingCustomCursorRectSprite  = function() { return true; };
          this._handlers = this._handlers || {};
          let langData = LanguageManager._data
          for (let lang in langData) {
            if (langData[lang].meta.id) {
              this.addCommand(langData[lang].meta.name, `_lang_${langData[lang].meta.id}`)
              this.setHandler(`_lang_${langData[lang].meta.id}`, (function() {
                //console.log(`${langData[lang].meta.id} lang`)
                LanguageManager.setLanguage(langData[lang].meta.id);
                if (!isSceneTitle) {DataManager.saveGame(44)};
                chrome.runtime.reload();
              }).bind(this))
            }
          }
        };
        getCommandHelpText(symbol = this.currentSymbol()) {
          let langData = LanguageManager._data
          for (let lang in langData) {
            if (langData[lang].meta && `_lang_${langData[lang].meta.id}` == symbol) {
              return langData[lang].meta.helptext;
            }
          }
          return "** ERROR ! ! ! **"
        };
        callUpdateHelp() {
          super.callUpdateHelp.call(this)
          if (this._helpWindow) {
            this._helpWindow.setText(this.getCommandHelpText());
          };
        }
        windowWidth() { return 620; }
        windowHeight() { return 274; }

        update() {
            super.update();
        }
    }

    function randomString(l) {
        return crypto.randomBytes(l).toString("hex");
    }


    class SystemOptionsWindow extends Window_OmoMenuOptionsCategory {
        constructor() {
            super(...arguments);
        }
        initialize() {
            super.initialize();
            this.setHandler("ok", this.onManageSystem.bind(this));

            this._meowSystemLanguage = new MeowSystemLanguage();
            this._meowSystemLanguage.deactivate();
            this._meowSystemLanguage.y = 44;
            this._meowSystemLanguage.setHandler('cancel', this.onWindowCancel.bind(this));
            this.addChild(this._meowSystemLanguage);

            this._optionWindows = [this._meowSystemLanguage];
        }

        makeCommandList() {
            this.addCommand("游戏语言", 'ok', true);
        }
        maxCols() {
            return 1;
        }

        passHelpWindow(helpWindow) {
              this._meowSystemLanguage._helpWindow = helpWindow;
            this._helpWindow = helpWindow;
        }
        onManageSystem() {
            this.deactivate();
            if (this.index() === 0) {
                this._meowSystemLanguage.activate();
                this._meowSystemLanguage.select(0);
            }
			else {
                this.activate();
            }
        }

        onWindowCancel() {


            if (this.index() === 0) {
                this._meowSystemLanguage.select(0);
                this._meowSystemLanguage.refresh();
            }

            this._helpWindow.clear();
            this.activate();
        }

        callUpdateHelp() {
            super.callUpdateHelp();
            if (this.index() === 0) {
                if (this._helpWindow) {
                    this._helpWindow.setText("在这里改变你的语言（这会重启游戏）");
                }
            }
        }
    }

    let _injection_point_title_screen = Scene_OmoriTitleScreen;
    window.Scene_OmoriTitleScreen = class Scene_OmoriTitleScreen extends _injection_point_title_screen {
        create() {
            super.create();
        }
        createSystemOptionsWindow() {
            super.createSystemOptionsWindow();
            this._meowSystemWindow = new SystemOptionsWindow();
            this._meowSystemWindow.setHandler('cancel', this.onOptionWindowCancel.bind(this));
            this._meowSystemWindow.deactivate();
            this._meowSystemWindow.passHelpWindow(this._helpWindow);
            this._optionsWindowsContainer.addChild(this._meowSystemWindow);
        }
        optionWindows() {
            let a = super.optionWindows();
            a.push(this._meowSystemWindow);
            return a;
        }
    }

    let _injection_point_scene_menuoptions = Scene_OmoMenuOptions;
    window.Scene_OmoMenuOptions = class Scene_OmoMenuOptions extends _injection_point_scene_menuoptions {
        createOptionCategoriesWindow() {
          console.log(this.optionWindows())
          super.createOptionCategoriesWindow()
        }
        createSystemOptionsWindow() {
                super.createSystemOptionsWindow()
                this._meowSystemWindow = new SystemOptionsWindow();
                this._meowSystemWindow.setHandler('cancel', this.onOptionWindowCancel.bind(this));
                this._meowSystemWindow.deactivate();
                this._meowSystemWindow.passHelpWindow(this._helpWindow);
                this._meowSystemWindow.visible = false;
                this._meowSystemWindow.height = 0;
                this._meowSystemWindow.x = 10;
                this.addChild(this._meowSystemWindow);
        }
        optionWindows() {
            let a = super.optionWindows();
            if (!spainMode) a.push(this._meowSystemWindow);
            return a;
        }
    }

    let _injection_point_options_category = Window_OmoMenuOptionsCategory;
    window.Window_OmoMenuOptionsCategory = class Window_OmoMenuOptionsCategory extends _injection_point_options_category {
        makeCommandList() {
            super.makeCommandList();
            this.addCommand('游戏语言', 'ok');
        }
        maxCols() { return super.maxCols() + 1; }
    }

    window.Window_MeowMenuOptionsSystem = new Proxy(SystemOptionsWindow, {
        construct(target, args, newTarget) {
            spainMode = true;
            return Reflect.construct(target, args, newTarget);
        }
    });

//░░░░░░░░▄▀▀████████▀██████▄▄▄▄▄▄░░░░░░
//░░░░░░▄▀░▄▀░░▄▄▄▄▄░▀▄▄▄▄▄▄▀▀▀▄▄░▀▄░░░░
//░░░░▄▀░░▀░▄▄▀░░░░░▀█▄░░░▄▀▀▀▀▄▀▀░░█░░░
//░░░▄▀░░░░▄▀░▄███▀▀▄░▀░░█░▄▄▄▄▄░░▄▄█▄░░
//░▄▀░░▄▀▀▄░░▀▀░▄▀▀▀██░░░██▀▀▀░▀▀░▀▀▀██▄
//█░░▄▀░▄▄░▀▀░▀▀░░▄░▄▄░░░░█▄░░▄▄▀▀▀█▄░██
//█░░█░▀█░▀█▄▄▄▄▄▀░█░▄▄▄░░░▀██▄░░░▄░░▄██
//█░░░▀░░█▄▄█░░▀▀▀█▄▄░░▀░▀▀▀▀░░▄▄▀▀█░█▀░
//░▀▄░░░░░▀▄▀█▀█▄▄█▄░▀▀█▀▀█▀▀▀█░▄████▀░░
//░░▀▄░░░░░▄▀█▄░▀████████████████████░░░
//░░░░▀▄▄░░░▀▄▀▀▄█░░░░░█░░█░░█░█░▄▀░█▄░░
//░░░░░░░▀▄░░░▀▄▄░▀▀▄▄█▀▀▀▀▀▀▀▀▀▀▄░░░█▄░
//░░░░░░░░░▀▀▄▄░░▀▀▄▄░░░▄▄▄▄▄▄▄░▀▄▄░░░█░
//░░░░░░░░░░░░░▀▀▀▄▄▄▀▀▀▀▀▀▀▀▀▀▀▀▀░░▄▀░░
//░░░░░░░░░░░░░░░░░░░▀▀▄▄▄▄▄▄▄▄▄▄▄▄▀░░░░
//▄▄▄░░▄▄▄▄░░░▄▄▄░░▄▄▄▄░░▄▄░░░▄▄▄░▄▄░░░▄
//█░██░██░██░██░██░██▄█▀░██░░░██▄░███▄██
//█▀▀░░██▀█▄░██░██░██░██░██░░░██▀░██▀█▀█
//█░░░░██░██░▀█▄█▀░████▀░████░███░██░░░█
//░░░░░░░░░░░░░░░░░░░░▄▄▄▄▄░░░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░▄███▀▀▀██▄░░░░░░░░░░░
//░░░░░░░░░░░░░░░░ ██░░░░░███░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░░░░▄▄▄██▀░░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░░░██▀▀▀░░░░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░░░██░░░░░░░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░░░▄▄░░░░░░░░░░░░░░░░░
//░░░░░░░░░░░░░░░░░░░▀▀░░░░░░░░░░░░░░░░░

//Also, whoever is reading this. Harambe would like to know your location

//A chance observation has led us, over a number of years, to investigate a great variety of different forms
//and symptoms of hysteria, with a view to discovering their precipitating cause - the event which provoked
//the first occurrence, often many years earlier, of the phenomenon in question. In the great majority of cases
//it is not possible to establish the point of origin by a simple interrogation of the patient, however thoroughly
//it may be carried out. This is in part because what is in question is often some experience which the patient
//dislikes discussing; but principally because he is genuinely unable to recollect it and often has no suspicion
//of the causal connection between the precipitating event and the pathological phenomenon. As a rule it is
//necessary to hypnotize the patient and to arouse his memories under hypnosis of the time at which the
//symptom made its first appearance; when this has been done, it becomes possible to demonstrate the
//connection in the clearest and most convincing fashion.

//nerd
